<%-- $Id: index.jsp 7703 2019-04-11 07:31:26Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginParameter"
	import="net.sf.basedb.core.ParameterType"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.core.IntegerParameterType"
	import="net.sf.basedb.core.LongParameterType"
	import="net.sf.basedb.core.FloatParameterType"
	import="net.sf.basedb.core.DoubleParameterType"
	import="net.sf.basedb.core.ItemParameterType"
	import="net.sf.basedb.core.DateParameterType"
	import="net.sf.basedb.core.TimestampParameterType"
	import="net.sf.basedb.core.BooleanParameterType"
	import="net.sf.basedb.core.FileParameterType"
	import="net.sf.basedb.core.PathParameterType"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Path"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.InternalJobQueue"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginConfigurationRequest"
	import="net.sf.basedb.core.PluginExecutionRequest"
	import="net.sf.basedb.core.PluginResponse"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.SimpleProgressReporter"
	import="net.sf.basedb.core.StringUtil"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.Response"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.InteractivePlugin"
	import="net.sf.basedb.core.plugin.ExportOutputStream"
	import="net.sf.basedb.core.signal.Signal"
	import="net.sf.basedb.core.signal.SignalHandler"
	import="net.sf.basedb.core.signal.SignalTarget"
	import="net.sf.basedb.core.signal.SimpleSignalSender"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.DuplicateWizardException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ContextUtil"
	import="net.sf.basedb.util.ContextUtil.ContextResult"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.util.ServletExportOutputStream"
	import="net.sf.basedb.clients.web.util.SimpleSignalProgressReporter"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Arrays"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.LinkedHashMap"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.EnumSet"
	import="java.io.PrintWriter"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%!
private static final Set<Item> EXPERIMENT_CONTEXTS = 
	EnumSet.of(Item.EXPERIMENT, Item.BIOASSAYSET, Item.BIOASSAY);

private static String getJspPage(PluginConfigurationRequest request, 
		PluginDefinition plugin, String defaultPage, String root)
{
	String jspPage = request.getRequestInformation().getJspPage();
	if (jspPage == null)
	{
		jspPage = defaultPage;
	}
	else if (jspPage.startsWith("/"))
	{
		// The path is absolute... if it starts with the context root
		// it must be removed because we are doing a forward action
		if (jspPage.startsWith(root)) jspPage = jspPage.substring(root.length()-1);
	}
	else
	{
		String className = plugin.getClassName();
		int lastDot = className.lastIndexOf('.');
		String packageName = lastDot == -1 ? "" : className.substring(0, lastDot+1);
		jspPage = "/plugins/"+packageName.replace('.', '/')+jspPage;
	}
	jspPage += "?requestId="+System.identityHashCode(request);
	return jspPage;
}
private static Experiment getCurrentExperiment(DbControl dc, GuiContext context)
{
	if (!EXPERIMENT_CONTEXTS.contains(context.getItem())) return null;
	SessionControl sc = dc.getSessionControl();
	ItemContext expCtx = sc.getCurrentContext(Item.EXPERIMENT);
	if (expCtx.getId() == 0) return null;
	return Experiment.getById(dc, expCtx.getId());
}
%>

<%
final String root = request.getContextPath()+"/";
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final boolean warnIfOpen = Values.getBoolean(request.getParameter("warnIfOpen"), true);
final boolean anotherIsOpen = sc.getSessionSetting("plugin.configure.plugin") != null;

DbControl dc = null;
String forward = null;
String message = null;
String redirect = null;
try
{

	if ("SelectPlugin".equals(cmd))
	{
		Item itemType = Item.valueOf(request.getParameter("item_type"));
		String subContext = Values.getString(request.getParameter("subcontext"), "");
		GuiContext.Type contextType = GuiContext.Type.valueOf(request.getParameter("context_type"));
		GuiContext context = new GuiContext(itemType, contextType, subContext);
		Plugin.MainType mainType = Plugin.MainType.valueOf(request.getParameter("main_type"));
		String pluginType = request.getParameter("plugin_type");

		ItemQuery<PluginDefinition> pluginQuery = PluginDefinition.getQuery(context, pluginType);
		pluginQuery.restrict(
			Restrictions.eq(
				Hql.property("mainType"),
				Expressions.integer(mainType.getValue())
			)
		);
		pluginQuery.restrict(Restrictions.eq(Hql.property("disabled"), Expressions.parameter("isDisabled", false)));
		pluginQuery.order(Orders.asc(Hql.property("name")));
		pluginQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
		
		ItemQuery<PluginConfiguration> configQuery = PluginConfiguration.getQuery();
		configQuery.restrict(
				Restrictions.eq(
					Hql.property("pluginDefinition"),
					Expressions.parameter("plugin")
				)
			);
		configQuery.restrict(Restrictions.gt(Hql.property("parameterVersion"), Expressions.integer(0)));
		configQuery.order(Orders.asc(Hql.property("name")));
		configQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
		
		dc = sc.newDbControl();
		Object currentItem = null;
		if (contextType == GuiContext.Type.ITEM)
		{
			currentItem = itemType.getById(dc, sc.getCurrentContext(itemType).getId());
		}
		List<ContextResult> contextResult = ContextUtil.checkContext(dc, pluginQuery, configQuery, context, currentItem);
		dc.close();

		boolean showWarnings = Values.getBoolean(sc.getUserClientSetting("plugins.showWarnings"), false);
		int totalPlugins = ContextUtil.countUsuablePlugins(contextResult);
		Set<String> contextMessages = ContextUtil.getContextMessages(contextResult, showWarnings, true);
		
		if (totalPlugins == 0)
		{
			String msg = "<b>No plugins can be used in this context, for the following reasons:</b><br><ul><li>";
			if (contextMessages.size() == 0)
			{
				msg += "Could not find any plugins that you have permission to use</ul>";
			}
			else
			{
				msg += Values.getString(contextMessages, "<li>", true) + "</ul>";
			}
			throw new WebException("popup", "No usable plugins found", msg);
		}
		sc.setSessionSetting("MESSAGES", contextMessages);
		sc.setSessionSetting("PLUGINS", contextResult);
		if (totalPlugins == 1 && contextMessages.size() == 0 && !(warnIfOpen && anotherIsOpen))
		{
			// Only one plug-in, that can be used, exists, find it in contextResult and 
			//go directly to parameter input page
			int i = 0;
			PluginDefinition thePlugin = null;
			PluginConfiguration theConfig = null;
			while (i < contextResult.size() && thePlugin == null)
			{
				if (contextResult.get(i).isInContext())
				{
					thePlugin = contextResult.get(i).getPluginDefinition();
					theConfig = contextResult.get(i).getPluginConfiguration();
				}
				i++;
			}
			int pluginDefinitionId = thePlugin.getId();
			int pluginConfigurationId = theConfig == null ? 0 : theConfig.getId();
			forward = "index.jsp?cmd=NewJob"+
				"&plugindefinition_id="+pluginDefinitionId+
				"&pluginconfiguration_id="+pluginConfigurationId;
		}
		else
		{
			forward = "select_plugin.jsp";
		}
	}
	else if ("ConfigurePlugin".equals(cmd))
	{
		if (warnIfOpen && anotherIsOpen) 
		{
			throw new DuplicateWizardException();
		}
		int pluginConfigurationId = Values.getInt(request.getParameter("pluginconfiguration_id"));
		
		dc = sc.newDbControl();
		PluginConfiguration pluginConfig = PluginConfiguration.getById(dc, pluginConfigurationId);
		PluginDefinition plugin = pluginConfig.getPluginDefinition();
		
		if (!plugin.supportsConfigurations())
		{
			throw new WebException("popup", "Configurations are not supported",
				"The plugin {1} doesn't support configurations.", HTML.encodeTags(plugin.getName()));
		}
		PluginConfigurationRequest pcRequest = pluginConfig.configure();
		
		sc.setSessionSetting("plugin.configure.request", pcRequest);
		sc.setSessionSetting("plugin.configure.job", null);
		sc.setSessionSetting("plugin.configure.plugin", plugin);
		sc.setSessionSetting("plugin.configure.config", pluginConfig);
		sc.setSessionSetting("plugin.configure.errors.message", null);
		sc.setSessionSetting("plugin.configure.errors.list", null);
		forward = getJspPage(pcRequest, plugin, "configure.jsp", root);
	}

	else if ("NewJob".equals(cmd))
	{
		if (warnIfOpen && anotherIsOpen) 
		{
			throw new DuplicateWizardException();
		}
		String pluginClass = request.getParameter("plugin_class");
		int pluginDefinitionId = Values.getInt(request.getParameter("plugindefinition_id"));
		int pluginConfigurationId = Values.getInt(request.getParameter("pluginconfiguration_id"));
		Item itemType = Item.valueOf(request.getParameter("item_type"));
		String subContext = Values.getString(request.getParameter("subcontext"), "");
		ItemContext currentContext = sc.getCurrentContext(itemType, subContext);
		GuiContext.Type contextType = GuiContext.Type.valueOf(request.getParameter("context_type"));
		GuiContext context = new GuiContext(itemType, contextType, subContext);
		
		dc = sc.newDbControl();
		PluginDefinition plugin = pluginClass == null ? 
			PluginDefinition.getById(dc, pluginDefinitionId) : PluginDefinition.getByClassName(dc, pluginClass);
		PluginConfiguration pluginConfig = pluginConfigurationId == 0 ? null : PluginConfiguration.getById(dc, pluginConfigurationId);
		Job job = Job.getNew(dc, plugin, pluginConfig, getCurrentExperiment(dc, context));
		String jobName = Values.getStringOrNull(request.getParameter("job_name"));
		job.setName(jobName == null ? "Run plugin: " + plugin.getName() : jobName);
		job.setDescription(request.getParameter("job_description"));
		
		PluginConfigurationRequest pcRequest = job.configure(context);
		sc.setSessionSetting("plugin.configure.request", pcRequest);
		sc.setSessionSetting("plugin.configure.job", job);
		sc.setSessionSetting("plugin.configure.plugin", plugin);
		sc.setSessionSetting("plugin.configure.config", pluginConfig);
		sc.setSessionSetting("plugin.configure.errors.message", null);
		sc.setSessionSetting("plugin.configure.errors.list", null);
		sc.setSessionSetting("plugin.configure.currentContext", currentContext);
		forward = getJspPage(pcRequest, plugin, "configure.jsp", root);
	}
	
	else if ("CopyJob".equals(cmd))
	{
		dc = sc.newDbControl();
		int jobId = Values.getInt(request.getParameter("job_id"));
		Job copyFrom = Job.getById(dc, jobId);
		PluginDefinition plugin = copyFrom.getPluginDefinition();
		PluginConfiguration pluginConfig = copyFrom.getPluginConfiguration();
		
		Item itemType = Item.valueOf(request.getParameter("item_type"));
		String subContext = Values.getString(request.getParameter("subcontext"), "");
		ItemContext currentContext = sc.getCurrentContext(itemType, subContext);
		GuiContext.Type contextType = GuiContext.Type.valueOf(request.getParameter("context_type"));
		GuiContext context = new GuiContext(itemType, contextType, subContext);

		Job job = Job.getNew(dc, plugin, pluginConfig, getCurrentExperiment(dc, context));
		job.copyParametersFrom(copyFrom);
		
		PluginConfigurationRequest pcRequest = job.configure(context);
		sc.setSessionSetting("plugin.configure.request", pcRequest);
		sc.setSessionSetting("plugin.configure.job", job);
		sc.setSessionSetting("plugin.configure.plugin", plugin);
		sc.setSessionSetting("plugin.configure.config", pluginConfig);
		sc.setSessionSetting("plugin.configure.errors.message", null);
		sc.setSessionSetting("plugin.configure.errors.list", null);
		sc.setSessionSetting("plugin.configure.currentContext", currentContext);
		forward = getJspPage(pcRequest, plugin, "configure.jsp", root);
	}
	
	else if ("ConfigureJob".equals(cmd))
	{
		dc = sc.newDbControl();

		int jobId = Values.getInt(request.getParameter("job_id"));
		Job job = Job.getById(dc, jobId);
		
		//Item itemType = Item.valueOf(request.getParameter("item_type"));
		//String subContext = Values.getString(request.getParameter("subcontext"), "");
		//GuiContext.Type contextType = GuiContext.Type.valueOf(request.getParameter("context_type"));
		GuiContext context = job.getLastGuiContext();
		
		PluginDefinition plugin = job.getPluginDefinition();
		PluginConfiguration pluginConfig = job.getPluginConfiguration();
		
		PluginConfigurationRequest pcRequest = job.configure(context);
		sc.setSessionSetting("plugin.configure.request", pcRequest);
		sc.setSessionSetting("plugin.configure.job", job);
		sc.setSessionSetting("plugin.configure.plugin", plugin);
		sc.setSessionSetting("plugin.configure.config", pluginConfig);
		sc.setSessionSetting("plugin.configure.errors.message", null);
		sc.setSessionSetting("plugin.configure.errors.list", null);
		forward = getJspPage(pcRequest, plugin, "configure.jsp", root);
	}

	else if ("SetParameters".equals(cmd))
	{
		int maxRecent = Base.getMaxRecent(sc);
		PluginConfigurationRequest pcRequest = sc.getSessionSetting("plugin.configure.request");		
		String requestId = request.getParameter("requestId");
		if (requestId != null && !requestId.equals(Integer.toString(System.identityHashCode(pcRequest))))
		{
			throw new WebException("popup", "Invalid request ID", "Data in your configuration wizard has become corrupted. Please re-start and try again.");
		}
		List<PluginParameter<?>> parameters =  pcRequest.getRequestInformation().getParameters();
		List<Throwable> parseErrors = new LinkedList<Throwable>();
		ItemContext currentContext = sc.getSessionSetting("plugin.configure.currentContext");
		// Clear old errors
		sc.setSessionSetting("plugin.configure.errors.message", null);
		sc.setSessionSetting("plugin.configure.errors.list", null);
		if (parameters != null && parameters.size() > 0)
		{
			for (PluginParameter<?> param : parameters)
			{
				ParameterType<?> pType = param.getParameterType();
				if (pType != null)
				{
					String[] sValues = request.getParameterValues("parameter:"+param.getName());
					boolean emptyIsNull = Values.getBoolean(request.getParameter("parameter:" + param.getName() + ":emptyIsNull"));
					if (emptyIsNull)
					{
						for (int i = 0; i < sValues.length; ++i)
						{
							if ("".equals(sValues[i])) sValues[i] = null;
						}
					}
					Object[] oValues = null;
					try
					{
						if (sValues != null)
						{
							if (pType instanceof StringParameterType)
							{
								oValues = sValues;
							}
							else if (pType instanceof IntegerParameterType)
							{
								oValues = Values.getInt(sValues);
							}
							else if (pType instanceof LongParameterType)
							{
								oValues = Values.getLong(sValues);
							}
							else if (pType instanceof FloatParameterType)
							{
								oValues = Values.getFloat(sValues);
							}
							else if (pType instanceof DoubleParameterType)
							{
								oValues = Values.getDouble(sValues);
							}
							else if (pType instanceof BooleanParameterType)
							{
								oValues = Type.BOOLEAN.parseStrings(sValues);
							}
							else if (pType instanceof DateParameterType)
							{
								oValues = Values.getDate(sValues, FormatterFactory.getDateFormatter(sc));
							}
							else if (pType instanceof TimestampParameterType)
							{
								oValues = Values.getDate(sValues, FormatterFactory.getDateTimeFormatter(sc));
							}
							else if (pType instanceof ItemParameterType)
							{
								Integer[] itemId = Values.getInt(sValues);
								oValues = new Object[itemId.length];
								Item iType = Item.fromClass((Class)pType.getParameterClass());
								dc = sc.newDbControl();
								for (int i = 0; i < itemId.length; ++i)
								{
									Integer id = itemId[i];
									if (id != null && id != 0)
									{
										BasicItem item = iType.getById(dc, id);
										oValues[i] = item;
										if (currentContext != null) 
										{
											currentContext.setRecent(iType, item, maxRecent);
										}
									}
								}
								dc.close();
							}
							else if (pType instanceof FileParameterType)
							{
								oValues = new Object[sValues.length];
								dc = sc.newDbControl();
								for (int i = 0; i < sValues.length; ++i)
								{
									File file = File.getByPath(dc, new Path(sValues[i], Path.Type.FILE), false);
									oValues[i] = file;
									if (currentContext != null) 
									{
										currentContext.setRecent(Item.FILE, file, maxRecent);
									}
								}
								dc.close();
							}
							else if (pType instanceof PathParameterType)
							{
								oValues = sValues;
							}
						}
					}
					catch (Throwable t)
					{
						parseErrors.add(t);
					}
					pcRequest.setParameterValues(param.getName(), oValues == null ? null : Arrays.asList(oValues));
				}
			}
		}
		PluginResponse pluginResponse = null;
		Response.Status status = null;
		if (parseErrors.size() == 0)
		{
			pluginResponse = pcRequest.invoke();
			status = pluginResponse.getStatus();
		}
		else
		{
			status = Response.Status.ERROR;
		}
		if (status == Response.Status.DONE || status == Response.Status.EXECUTE_IMMEDIATELY)
		{
			Job job = sc.getSessionSetting("plugin.configure.job");
			if (job != null)
			{
				String suggestedJobName = pluginResponse.getSuggestedJobName();
				if (suggestedJobName != null) job.setName(StringUtil.trimString(suggestedJobName, Job.MAX_NAME_LENGTH));
				sc.setSessionSetting("plugin.configure.response", pluginResponse);
				forward = "finish_job.jsp";
			}
			else
			{
				dc = sc.newDbControl();
				pluginResponse.saveParameters(dc);
				dc.commit();
				sc.setSessionSetting("plugin.configure.request", null);
				sc.setSessionSetting("plugin.configure.plugin", null);
				sc.setSessionSetting("plugin.configure.config", null);
				sc.setSessionSetting("plugin.configure.currentContext", null);
				message = "Plugin configured";
			}
		}
		else if (status == Response.Status.CONTINUE)
		{
			pcRequest = pluginResponse.getNextRequest();
			sc.setSessionSetting("plugin.configure.request", pcRequest);
			PluginDefinition plugin = sc.getSessionSetting("plugin.configure.plugin");
			forward = getJspPage(pcRequest, plugin, "configure.jsp", root);
		}
		else if (status == Response.Status.ERROR)
		{
			PluginDefinition plugin = sc.getSessionSetting("plugin.configure.plugin");
			if (parseErrors.size() > 0)
			{
				sc.setSessionSetting("plugin.configure.errors.message", 
					parseErrors.size() + " parameter value(s) are invalid");
				sc.setSessionSetting("plugin.configure.errors.list", parseErrors);
			}
			else
			{
				sc.setSessionSetting("plugin.configure.errors.message", pluginResponse.getMessage());
				sc.setSessionSetting("plugin.configure.errors.list", pluginResponse.getErrorList());
			}
			forward = getJspPage(pcRequest, plugin, "configure.jsp", root);
		}
		else if (status == Response.Status.DOWNLOAD_IMMEDIATELY)
		{
			sc.setSessionSetting("plugin.configure.response", pluginResponse);
			forward = "download_immediately.jsp";
		}
		else
		{
			throw new WebException("popup", "Unknown response from plugin", status.toString());
		}
	}
	else if ("FinishNewJob".equals(cmd))
	{
		dc = sc.newDbControl();
		Job job = sc.getSessionSetting("plugin.configure.job");
		if (job.isInDatabase()) 
		{
			dc.reattachItem(job, false);
		}
		else
		{
			dc.saveItem(job);
		}
		
		PluginResponse pluginResponse = sc.getSessionSetting("plugin.configure.response");
		boolean executeImmediately =
			pluginResponse != null && pluginResponse.getStatus() == Response.Status.EXECUTE_IMMEDIATELY;

		job.setName(Values.getStringOrNull(request.getParameter("name")));
		job.setDescription(Values.getStringOrNull(request.getParameter("description")));
		job.setSendMessage(Values.getBoolean(request.getParameter("send_message")));
		job.setRemoveJobWhenFinished(Values.getBoolean(request.getParameter("remove_job")));
		if (!Values.getBoolean(request.getParameter("resume_from_breakpoint")))
		{
			job.clearExecuteCommand();
		}
		if (!executeImmediately)
		{
			int agentId = Values.getInt(request.getParameter("agent_id"), -1);
			if (agentId >= 0)
			{
				job.setJobAgent(agentId == 0 ? null : JobAgent.getById(dc, agentId));
			}
		}
		
		if (pluginResponse != null) pluginResponse.saveParameters(dc);
		dc.commit();
		redirect = "../../views/jobs/index.jsp?ID="+ID+"&cmd=ViewItem&item_id="+job.getId();
		sc.setSessionSetting("plugin.configure.job", null);
		sc.setSessionSetting("plugin.configure.request", null);
		sc.setSessionSetting("plugin.configure.response", null);
		sc.setSessionSetting("plugin.configure.plugin", null);
		sc.setSessionSetting("plugin.configure.config", null);
		sc.setSessionSetting("plugin.configure.currentContext", null);
		if (executeImmediately)
		{
			PluginExecutionRequest executionRequest = pluginResponse.getExecutionRequest(null);
			executionRequest.registerSignalReceiver(InternalJobQueue.getSignalReceiver());
			Thread t = new Thread(executionRequest);
			t.setPriority(Thread.currentThread().getPriority() - 1);
			t.start();
		}
	}
	else if ("ExportImmediately".equals(cmd))
	{
		out.clearBuffer();
		PluginResponse pluginResponse = sc.getSessionSetting("plugin.configure.response");
		ExportOutputStream exportStream = new ServletExportOutputStream(response);
		SimpleSignalProgressReporter progress = new SimpleSignalProgressReporter(null);
		sc.setSessionSetting("plugin.configure.progress.reporter", progress);
		try
		{
			pluginResponse.downloadImmediately(exportStream, progress);
		}
		catch (Throwable t)
		{
			PrintWriter pw = new PrintWriter(exportStream, true);
			t.printStackTrace(pw);
			pw.flush();
			pw.close();
		}
		exportStream.flush();
		exportStream.close();
		sc.setSessionSetting("plugin.configure.job", null);
		sc.setSessionSetting("plugin.configure.request", null);
		sc.setSessionSetting("plugin.configure.response", null);
		sc.setSessionSetting("plugin.configure.plugin", null);
		sc.setSessionSetting("plugin.configure.config", null);
		sc.setSessionSetting("plugin.configure.errors.message", null);
		sc.setSessionSetting("plugin.configure.errors.list", null);
		sc.setSessionSetting("plugin.configure.currentContext", null);
		return;
	}
	else if ("CancelWizard".equals(cmd))
	{
		PluginConfigurationRequest pcRequest = sc.setSessionSetting("plugin.configure.request", null);
		SimpleSignalProgressReporter progress = sc.getSessionSetting("plugin.configure.progress.reporter");
		if (progress != null) progress.sendToAll(new SimpleSignalSender(Signal.ABORT));
		if (pcRequest != null) pcRequest.done();
		sc.setSessionSetting("plugin.configure.response", null);
		sc.setSessionSetting("plugin.configure.plugin", null);
		sc.setSessionSetting("plugin.configure.config", null);
		sc.setSessionSetting("plugin.configure.job", null);
		sc.setSessionSetting("plugin.configure.errors.message", null);
		sc.setSessionSetting("plugin.configure.errors.list", null);
		sc.setSessionSetting("plugin.configure.currentContext", null);
		sc.setSessionSetting("plugin.configure.progress.reporter", null);
		redirect = root + "common/close_popup.jsp?refresh_opener=0&wait=0";
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	sc.setSessionSetting("alert-message", message);
	pageContext.forward(forward);
}
else if (redirect != null)
{
	sc.setSessionSetting("alert-message", message);
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>
