<%-- $Id: logout.jsp 7605 2019-02-26 10:10:15Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	Logout from BASE.

	@param noconfirm
		If specified on the URL we display a confirmation dialogue
		otherwise we just log out and forward to the /main.jsp page

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getSessionControl(pageContext, false);
final boolean noconfirm = sc == null || !sc.isLoggedIn() ||
		Values.getBoolean(request.getParameter("noconfirm"));
final String ID = sc == null ? "" : sc.getId();
if (noconfirm)
{
	// Redirect to main login page
	String redirect = "common/close_popup.jsp?ID="+ID+"&wait=0&redirect_opener=../main.jsp?ID="+ID;;
	if (sc != null)
	{
		if (sc.isImpersonated())
		{
			SessionControl original = sc.getSessionSetting("impersonate.originalSessionControl");
			boolean revert = Values.getBoolean(request.getParameter("revert"));
			if (revert)
			{
				redirect = "common/close_popup.jsp?ID="+original.getId()+"&wait=0&redirect_opener=../my_base/index.jsp?ID="+original.getId();
			}
			else
			{
				original.logout();
			}
		}
		sc.logout();
	}
	response.sendRedirect(redirect);
	return;
}
String title = sc != null && sc.isImpersonated() ? "Logout impersonated?" : "Logout?";
%>
<base:page type="popup" title="<%=title%>">
<base:head scripts="~logout.js" />
<base:body data-read-only="1">
	<h1><%=title%></h1>
	<div class="content">
	<table class="fullcc bg-filled-50 bottomborder"><tr><td>
		<form action="logout.jsp" method="post" name="logout">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="noconfirm" value="1">
			<div id="confirm">
				<b>Are you sure you want to logout? </b>
				<br>
				All unsaved data will be lost!
				<% 
				if (sc.isImpersonated())
				{
					User originalUser = sc.getSessionSetting("impersonate.originalUser");
					if (originalUser != null)
					{
						%>
						<p>
						<input type="checkbox" name="revert" id="revert" value="1" checked><label for="revert">Revert to 
						<%=HTML.encodeTags(originalUser.getName())%></label>
						<%
					}
				}
				%>
			</div>
			<div id="logout" style="display: none;">
				<b>Logging out...</b>
			</div>
		</form>
	</td></tr></table>
	</div>
	<base:buttongroup subclass="dialogbuttons" id="dialogbuttons">
		<base:button id="btnLogout" title="Yes" />
		<base:button id="close" title="No" />
	</base:buttongroup>
</base:body>
</base:page>
