<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemList"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final Item itemType = Item.ITEMLIST;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Item memberType = Item.valueOf(request.getParameter("memberType"));
	String formId = Values.getStringOrNull(request.getParameter("formId"));
	String subContext = Values.getString(request.getParameter("subContext"), "");
	
	ItemContext memberContext = sc.getCurrentContext(memberType, subContext);
	List<ItemList> recentLists = memberContext.getRecent(dc, Item.ITEMLIST, "AddMembers");
	%>
	<base:page type="popup" title="Add items to existing list">
	<base:head scripts="~add_items.js,linkitems-2.js">
	</base:head>
	<base:body>
		<h1>Add items to existing list</h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="additems">
		<input type="hidden" name="cmd" value="AddMembers">
		<%
		if (subContext != null)
		{
			%>
			<input type="hidden" name="subContext" value="<%=subContext%>">
			<%
		}
		%>
		<div id="page-data" class="datacontainer"
			data-member-type="<%=memberType.getValue()%>"
		></div>
		
		<div class="content bottomborder">
			<table class="fullform input100">
			<tr>
				<th>Which list?</th>
				<td>
					<base:select 
						id="item_id"
						clazz="selectionlist"
						required="true"
						current="<%=null%>"
						recent="<%=recentLists%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr class="big">
				<th>Which items?</th>
				<td>
					<input type="radio" name="source" id="sourceSelected" value="selected"
						data-parent-form="<%=formId%>"
						><label for="sourceSelected" id="lblSelected">Selected items</label><br>
					<input type="radio" name="source" id="sourcePage" value="page"
						><label for="sourcePage">Current page</label><br>
					<input type="radio" name="source" id="sourceAll" value="all" checked
						><label for="sourceAll">All pages</label><br>
				</td>
				<td></td>
			</tr>
			</table>
		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnAdd" title="Add" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
